//+-------------------------------------------------------------------------------------+
//|                                                                   HistoryToFile.mq4 |
//|                                                                           Scriptong |
//|                                                                   scriptong@mail.ru |
//+-------------------------------------------------------------------------------------+
#property copyright "Scriptong"
#property link      "scriptong@mail.ru"

#property show_inputs

extern string    A0 = "  (  -  )";
extern string    SymbolName = "";
extern string    A0_1 = "=================================================";
extern string    A1 = "   ( -  -1)";
extern int       MagicNumber = -1;
extern string    A1_1 = "=================================================";
extern string    A2 = " ,     ";
extern string    FileName = "report.csv";
extern string    A2_1 = "=================================================";

int FileHandle, PipsInAll;
double CurrencyInAll;

//+-------------------------------------------------------------------------------------+
//|                                                                        |
//+-------------------------------------------------------------------------------------+
bool OpenFile()  
{
// - 1 - ==================    ======================================
 FileHandle = FileOpen(FileName, FILE_CSV|FILE_WRITE);
 if (FileHandle < 1)
   {
    Alert("    ", FileName, "  !");
    return(False);
   }
// - 1 - ==================   =============================================

// - 2 - ==================    ======================================
 if (FileWrite(FileHandle, "", "/ ", " ", "", 
               "", " ", "S/L", "T/P", "/ ", 
               " ", "", ", ", ", ") < 0)
   {
    Alert("    !");            
    return(False);            
   } 
// - 2 - ==================   =============================================

 return(True);  
}

//+-------------------------------------------------------------------------------------+
//|                                                      |
//+-------------------------------------------------------------------------------------+
string NumToStr(int Type)
{
 switch(Type)
  {
   case 0: return("Buy      "); break;
   case 1: return("Sell     "); break;
   case 2: return("BuyLimit "); break;
   case 3: return("SellLimit"); break;
   case 4: return("BuyStop  "); break;
   case 5: return("SellStop "); break;
  }
}

//+-------------------------------------------------------------------------------------+
//|     Excel -              |
//+-------------------------------------------------------------------------------------+
string DoubleToExcel(double Num, int Precision)
{
 string S = DoubleToStr(Num, Precision);
 int index = StringFind(S, ".", 0);
 if(index > -1)
   S = StringSetChar(S, index, 44);
 return(S);  
} 
 
//+-------------------------------------------------------------------------------------+
//|                                                            |
//+-------------------------------------------------------------------------------------+
bool WriteInFile()
{
// - 1 - ==================      ==================
 int Dig = MarketInfo(OrderSymbol(), MODE_DIGITS);            //   
 double Points = MarketInfo(OrderSymbol(), MODE_POINT);                  //  
 
 if (GetLastError() == 4106 || Points == 0)                       //   
   if (FileWrite(FileHandle, OrderTicket(), TimeToStr(OrderOpenTime()), 
                 NumToStr(OrderType()), DoubleToStr(OrderLots(), 2), OrderSymbol(), 
                 " .", " .", " .", TimeToStr(OrderCloseTime()),
                 " .", DoubleToExcel(OrderSwap(), 2), 
                 DoubleToExcel(OrderProfit(), 2), " .") < 0)
     {
      Alert("   !");                
      return(False);            
     } 
// - 1 - ==================   =============================================
   
// - 2 - ==================     ================================
 if (OrderType() == OP_BUY)
   int ProfitPoints = MathRound((OrderClosePrice() - OrderOpenPrice())/Points);
  else
   if (OrderType() == OP_SELL)
     ProfitPoints = MathRound((OrderOpenPrice() - OrderClosePrice())/Points);
    else
     ProfitPoints = 0; 
 PipsInAll += ProfitPoints; 
 CurrencyInAll += OrderSwap() + OrderProfit();   
// - 2 - ==================   =============================================
   
// - 3 - ==================     ========================================
 if (FileWrite(FileHandle, OrderTicket(), TimeToStr(OrderOpenTime()), 
               NumToStr(OrderType()), DoubleToExcel(OrderLots(), 2), OrderSymbol(), 
               DoubleToExcel(OrderOpenPrice(), Dig), DoubleToExcel(OrderStopLoss(), Dig),
               DoubleToExcel(OrderTakeProfit(), Dig), TimeToStr(OrderCloseTime()),
               DoubleToExcel(OrderClosePrice(), Dig), DoubleToExcel(OrderSwap(), 2),
               DoubleToExcel(OrderProfit(), 2), ProfitPoints) < 0)
   {
    Alert("   !");                
    return(False);            
   } 
// - 3 - ==================   =============================================
 return(True);
}

//+-------------------------------------------------------------------------------------+
//|                                                                        |
//+-------------------------------------------------------------------------------------+
bool CloseFile()
{
 if (FileWrite(FileHandle, "") < 0 ||     //       
     FileWrite(FileHandle, "", "", "", "", "", "", "", "", "", "", "", 
           DoubleToExcel(CurrencyInAll, 2), DoubleToStr(PipsInAll, 0)) < 0)    // ""
   {
    Alert("   !");                
    return(False);            
   } 
           
 FileClose(FileHandle);                                                 //  
 return(True);
}


//+-------------------------------------------------------------------------------------+
//| script program start function                                                       |
//+-------------------------------------------------------------------------------------+
int start()
  {
// - 1 - ==================   ==============================================
   if (!OpenFile()) return(0);
// - 1 - ==================   =============================================
   
// - 2 - ==================       =======================
   CurrencyInAll = 0;
   PipsInAll = 0;
   for (int i = 0; i < OrdersHistoryTotal(); i++)
     if (OrderSelect(i, SELECT_BY_POS, MODE_HISTORY))
       if (OrderType() >= 0 && OrderType() < 6)
         if (OrderSymbol() == SymbolName || SymbolName == "")
           if (OrderMagicNumber() == MagicNumber || MagicNumber == -1)
             if (!WriteInFile())
                return(0);
// - 2 - ==================   =============================================
           
// - 3 - ============         ==============
   if (!CloseFile()) return(0);
   
   Alert("   !");        
// - 3 - ==================   =============================================
   
   return(0);
  }

